/**
 * Demonstrates the functionality of references in
 * comparison to primitive data types.
 */
class References_2 {

	public static void main(String[] args) {

		// definitions
		Point p1, p2;

		// Initialization

		p1 = null;
		p2 = new Point();

		System.out.println();
		System.out.println("Values of the reference variables are:");
		System.out.println();
		System.out.println("   p1 = " + p1);
		System.out.println("   p2 = " + p2);
		System.out.println();

		// Will not work currently
		// System.out.println("   p1 = (" + p1.x + "," + p1.y + ")");

		// Create p1 and move p2

		p1 = new Point();
		p2.moveTo(2,3);

		System.out.println();
		System.out.println("Classes are reference types:");
		System.out.println();
		System.out.println("   p1 = " + p1);
		System.out.println("   p2 = " + p2);
		System.out.println();

		System.out.println("   p1 = (" + p1.x + "," + p1.y + ")");
		System.out.println("   p2 = (" + p2.x + "," + p2.y + ")");
		System.out.println();

		System.out.println("Now p2 = p1 will be set.");
		System.out.println();

		p2 = p1;

		System.out.println("   p1 = " + p1);
		System.out.println("   p2 = " + p2);
		System.out.println();

		System.out.println("After moving p1 to (4,5):");

		p1.moveTo(4,5);

		System.out.println();
		System.out.println("   p1 = (" + p1.x + "," + p1.y + ")");
		System.out.println("   p2 = (" + p2.x + "," + p2.y + ")");
		System.out.println();

		// primitive types for comparison

		int num1 = -12;
		int num2 = 4;

		num2 = num1;

		num1 = 99;

		System.out.println("num1 = " + num1);
		System.out.println("num2 = " + num2);
	}
} 
